---Collision Function----
function CheckCollision(ax1,ay1,aw,ah, bx1,by1,bw,bh)
  local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh
  return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end

--Glowing Shape Code (Nova-Fusion)
function glowShape(r, g, b, type, ...)
  love.graphics.setColor(r, g, b, 15)
  
  for i = 10, 2, -1 do
    if i == 2 then
      i = 1
      love.graphics.setColor(r, g, b, 255)    
    end
    
    love.graphics.setLineWidth(i)
    
    if type == "line" then
      love.graphics[type](...)
    else
      love.graphics[type]("line", ...)
	end
			
	
		end
	end



function love.load()
	
    love.window.setTitle('The Cubistan') --Caption
	
	--Background color--
	r = math.random(120, 200)
	g = math.random (160, 230)
	b = math.random(30, 70)
	
	--Tutorial--
	tutorialtext = love.graphics.setNewFont('Squareo.ttf', 60)
	
	--Score--------
	scoretext = love.graphics.setNewFont('Squareo.ttf', 250)
	score = 0

	--Loading Hero :3-
	hero = {}
	hero.x, hero.y = love.mouse.getPosition()
	hero.speed = 150
	hero.height = 29
	hero.width = 29
		

	--'Pellet'--
	pellet = {}
	pellet.x = math.random(630)
	pellet.y = math.random(470)
	pellet.height = 15
	pellet.width = 15
	
	--Good Pellet aka Angel
	goodpellet = {}
	goodpellet.x = 800
	goodpellet.y = 800
	goodpellet.height = 30
	goodpellet.width = 30
	

	--'Baddie'----
	baddie = {}
	baddie.x = math.random(630)
	baddie.y = math.random(470)
	baddie.height = 25
	baddie.width = 25
	
	--'Evil'---
	evil = {}
	evil.x = 900
	evil.y = 900
	evil.height = 55
	evil.width = 55

	
	--Music----
	music = love.audio.newSource('bgm.ogg')
	love.audio.play(music)
	
	

	--Time for baddie (and evil) place change----
	countdownTime_baddie = 3
	countdownTime_evil = 3
	countdownTime_angel = 3
	
end

--------------------

function love.update(dt)

--Keyboard (and mouse)------------------------------------
	if love.keyboard.isDown('left') then
		hero.x = hero.x - (hero.speed*dt)
	
	elseif love.keyboard.isDown('right') then
		hero.x = hero.x + (hero.speed*dt)

	end

	if love.keyboard.isDown('up') then
		hero.y = hero.y - (hero.speed*dt)

	elseif love.keyboard.isDown('down') then
		hero.y = hero.y + (hero.speed*dt)
	end

	if love.mouse.isVisible() then --sets mouse invisible
		love.mouse.setVisible()
	end
---------------------------------------

--Collision Checking (and actions for it)
	--Hero-pellet collision
	if CheckCollision(hero.x, hero.y, hero.height, hero.width, pellet.x, pellet.y, pellet.height, pellet.width) then
		pellet.x = math.random(630)
		pellet.y = math.random(470)
		-------
		score = score + 1
		hero.speed = hero.speed + 3.5 
		-------
	
    --Hero-baddie collision check
	elseif CheckCollision(hero.x, hero.y, hero.height, hero.width, baddie.x, baddie.y, baddie.height, baddie.width) then
		score = score - 5
		hero.speed = hero.speed - 30
		baddie.x = math.random(630)
		baddie.y = math.random(470)
		
	--Hero-evil check
	elseif CheckCollision(hero.x, hero.y, hero.height, hero.width, evil.x, evil.y, evil.height, evil.width) then
		score = score - 10
		hero.speed = hero.speed - 40
		evil.x = math.random(630)
		evil.y = math.random(470)
		
		--Hero-goodPellet check
	elseif CheckCollision(hero.x, hero.y, hero.height, hero.width, goodpellet.x, goodpellet.y, goodpellet.height, goodpellet.width) then
		score = score + 2
		goodpellet.x = math.random(630)
		goodpellet.y = math.random(470)
		
		
		
    --Checks if baddie and pellet overlap. If true, 'rerolls' baddie's place
	elseif CheckCollision(pellet.x, pellet.y, pellet.height, pellet.width, baddie.x, baddie.y, baddie.height, baddie.width) then
		baddie.x = math.random(630)
		baddie.y = math.random(470)
	end
		
	--Music Looping--
	if not music:isLooping() then
		music:setLooping(true)
		
	end
		

----------------------------

--Boundary Checking-------------
	if hero.x < 0 then
		hero.x = 0
	elseif hero.x > love.graphics.getWidth() - hero.width then
		hero.x = love.graphics.getWidth() - hero.width
	elseif hero.y < 0 then
		hero.y = 0
	elseif hero.y > love.graphics.getHeight() - hero.height then
		hero.y = love.graphics.getHeight() - hero.height
	end

--Baddie (and evil) place change every (countDownTime) seconds.
--Thanks Syca for this code ^_^
	
countdownTime_baddie = countdownTime_baddie - dt
--	
	if  countdownTime_baddie < 0 then
		baddie.x = math.random(630)
		baddie.y = math.random(470)
		countdownTime_baddie = 2.5
	end
--
countdownTime_evil = countdownTime_evil - dt

	--Evil version >:D
	if score > 50 then
		if countdownTime_evil < 0 then
		evil.x = math.random(630)
		evil.y = math.random(470)
		countdownTime_evil = 4
		end
	else
		evil.x = 900
		evil.y = 900
	end
	
--
countdownTime_angel = countdownTime_angel - dt

	--Good One :3
	if score > 75 then
		if countdownTime_angel < 0 then
		goodpellet.x = math.random(630)
		goodpellet.y = math.random(470)
		countdownTime_angel = 2.5
		end
	else
		goodpellet.x = 900
		goodpellet.y = 900
	end
end

--------------------

function love.draw()
--Tutorial

	if score < 3 then
		love.graphics.setFont(tutorialtext)
		love.graphics.setColor(0, 255, 106)
		love.graphics.printf('Green cubes are good. They make you faster.', 70, 200, 640, 'center')
	elseif score < 6 then
		love.graphics.setColor(115, 0 ,0)
		love.graphics.printf('Red cubes are evil! They make you slower and take 5 points.', 70, 200, 640, 'center')
	elseif score < 10 then
		love.graphics.setColor(255,255,255)
		love.graphics.printf('Surprise at 250 :)', 70, 200, 640, 'center')
	elseif score == 51 then
		love.graphics.printf('THIS IS DEVIL HIMSELF! He takes away 10 points.', 70, 200, 640, 'center')
	elseif score > 249  then
		love.graphics.setColor(255,255,255)
		love.graphics.printf('You are the best! ;)', 70, 200, 640, 'center')
	elseif score == 75  then
		love.graphics.setColor(0, 255, 255)
		love.graphics.printf('This is Angel. He will give 2 points.', 70, 200, 640, 'center')
	end
--Score
	love.graphics.setColor(255,255,255)
	love.graphics.printf(score, 70, 100, 640, 'center')

--Hero :3 
	glowShape(36, 100, 255, 'rectangle', hero.x, hero.y, 35,35)
	
--Pellet
	glowShape(0, 255, 106, 'rectangle', pellet.x, pellet.y, 20,20)

--Baddie
	glowShape(199, 0, 33, 'rectangle', baddie.x, baddie.y, 25,25)
	
--Devil
	if score > 50 then
		glowShape(115, 0 ,0, 'rectangle', evil.x, evil.y, 40, 40)
	end
	
--Good Pellet
	if score > 74 then
		glowShape(0, 255, 255, 'rectangle', goodpellet.x, goodpellet.y, goodpellet.height, goodpellet.width)
	    love.graphics.setColor(0, 255, 255)
	end
end
	

		







  
